import { select, json, geoPath, geoNaturalEarth1} from 'd3';
import { feature } from 'topojson';

// Selects the SVG from the HTML
const svg = select('svg');

// Create a new geoNaturalEarth1() object for generating and projecting paths
const projection = geoNaturalEarth1();
const pathGenerator = geoPath().projection(projection);

//Renders the path to a Canvas by appending path generated by pathgenerator to svg
svg.append('path')
    .attr('class', 'sphere')
    .attr('d', pathGenerator({type: 'Sphere'}));


// Fetches the data from the end point and then formats it project on the canvas.
json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
  .then(data => {
  	// Extracts the all the countries from the data
    const countries = feature(data, data.objects.countries);
  	// Passes the extracted countries as data for generating the paths on the canvas
    svg.selectAll('path').data(countries.features)
      .enter().append('path')
        .attr('class', 'country')
        .attr('d', pathGenerator);
  });
